unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DB, DBClient, Grids, DBGrids, StdCtrls, ExtCtrls, DBCtrls,
  TeEngine, Series, TeeProcs, Chart, DbChart;

type
  TForm1 = class(TForm)
    DBGrid1: TDBGrid;
    DataSource1: TDataSource;
    DBNavigator1: TDBNavigator;
    cds: TClientDataSet;
    cdsRecNo: TIntegerField;
    cdsItemNo: TStringField;
    cdsItemName: TStringField;
    cdsPrice: TCurrencyField;
    cdsQty: TIntegerField;
    cdsAmount: TCurrencyField;
    Label1: TLabel;
    DBText1: TDBText;
    cdsTotal: TAggregateField;
    Edit1: TEdit;
    DBChart1: TDBChart;
    Series1: TPieSeries;
    procedure CDSAfterPost(DataSet: TDataSet);
    procedure DBGrid1Enter(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure DBGrid1ColEnter(Sender: TObject);
    procedure cdsCalcFields(DataSet: TDataSet);
    procedure DBGrid1TitleClick(Column: TColumn);
  private
    Col : integer;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.CDSAfterPost(DataSet: TDataSet);
begin
  cds.MergeChangeLog; // only good to local file dataset;
end;

procedure TForm1.DBGrid1Enter(Sender: TObject);
begin
  DBGrid1ColEnter(Sender);
  PostMessage( DBGrid1.Handle, WM_LBUTTONDOWN, 0, 0 ); // work around the no cursor bug.
  PostMessage( DBGrid1.Handle, WM_LBUTTONUp, 0, 0 );
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  CDS.Active := true;
end;

procedure TForm1.DBGrid1ColEnter(Sender: TObject);
begin
  case DBGrid1.SelectedIndex of  // do not allow focus of RecNo and Amount
    0 : DBGrid1.SelectedIndex := 1;
    5 : DBGrid1.SelectedIndex := 4;
  end;
end;

procedure TForm1.cdsCalcFields(DataSet: TDataSet);
begin
  if cds.State = dsInsert then  // Dynamic generation of RecNo
    cdsRecNo.Value := cds.RecordCount + 1
  else
    cdsRecNo.Value := cds.RecNo;
  cdsAmount.Value := cdsPrice.Value * cdsQty.Value; // Calculate Amount
end;

procedure TForm1.DBGrid1TitleClick(Column: TColumn);
begin
  case Column.Index of
    0 : cds.IndexFieldNames := ''; // no Index
    5 :                            // Amount Column, no change
  else
    cds.IndexFieldNames := Column.FieldName; // Sort by Clicked Column
  end;
end;

end.
